﻿(function()
{
    var interval;
    var timeOut;
    var obj =
    {
        setting : new Object(),
        panels : new Array(),
        needResizeHeight:new Boolean(),
        //html需要的高度
        needHeight:0,

        // 渲染图片
		renderImage : function(panel, autoPlay, checkOffline)
		{
		    var status = panel.attr("status");
		    // 未加载
		    if(status == 0)
		    {
                var panel_ori = panel.find(".img-original");
                var img = $(panel.find(".img-original>img").get(0));
                var url = panel.attr("original-src");
                var canRender = true;

		        // 离线模式
		        if(checkOffline && !obj.setting.isOnLine)
		        {
                    if(!JNative.exists(url,obj.setting.articleId))
                    {
                        canRender = false;
                    }
		        }

		        if(canRender)
		        {
                    img.attr("src", panel.attr("original-src"));
                    panel.find(".loadingImgText").html(this.setting.loadingImgText);
                    img.bind('load', function()
                    {
                        var panel_def = panel.find(".img-default");
                        var panel_ori = panel.find(".img-original");
                        panel_def.remove();
                        panel_ori.fadeIn(300);
                        panel.attr("status", "1");
                        if(obj.needResizeHeight){
                            //未获取到图片高度时，当成滚动获取高度变化来处理。
                             this.autoResizeHeight();
                        }
                    });
                    img.bind('error', function()
                    {
                        panel.find(".loadingImgText").html(obj.setting.showImgText);
                    });
		        }
		    }
		    // 已加载， 回调Native
		    else
		    {
		        var panel_ori = panel.find(".img-original");
                var img = $(panel.find(".img-original>img").get(0));
                //JNative.onImageClickListener(img.attr('src'));
		    }
		},

        // 渲染视频
        renderVideo : function(panel, autoPlay)
        {
            var panel_def = panel.find(".video-default");
            if(panel_def && panel_def.length > 0)
            {
                var panel_ori = panel.find(".video-original");
                panel_def.remove();
                panel_ori.show();
                var video = panel.find('video');
                video.attr("src", panel.attr("original-src"));
                video.attr("poster", panel.attr("original-poster"));
                if(autoPlay)
                {
                    video.get(0).play();
                }
            }
        },

        // 渲染iframe视频
        renderIframeVideo : function(panel, autoPlay)
        {
            var panel_def = panel.find(".video-default");
            if(panel_def && panel_def.length > 0)
            {
                var panel_ori = panel.find(".video-original");
                panel_def.remove();
                panel_ori.show();

                var iframe = $(panel_ori.find("iframe").get(0));
                iframe.attr("src", panel.attr("original-src"));
            }
        },

        // 滚动自动渲染
        autoScrollRender : function(scrollTop)
        {
            var from = scrollTop - screen.height;
            var to = screen.height + (from > 0? from: 0) + screen.height;


            for(var i = 0 ; i < this.panels.length; i++)
            {
                var panel = $(this.panels[i]);
                var top = panel.offset().top;
                if(top > from && top < to)
                {
                    switch(panel.attr("type"))
                    {
                    case "img":
                      this.renderImage(panel, true, true);
                      break;
                    case "video":
                      this.renderVideo(panel, false);
                      break;
                    case "iframe-video":
                      this.renderIframeVideo(panel, false);
                      break;
                     case "iframe":
                       break;
                    }
                }
            }

        },

        // 渲染UI
        render : function(cfg)
        {
            this.setting = JSON.parse(cfg);

            var data = JNative.getNews(this.setting.articleId,this.setting.isOnLine);
            data = JSON.parse(data);

            // 正则替换， 取消浏览器立即加载
            // 替换src
            data.html = data.html.replace(/ src=/g, " original-src=");
            // 替换poster
            data.html = data.html.replace(/ poster=/g, " original-poster=");

            document.querySelector("section").innerHTML = data.html;
            var body_width = this.setting.width;
            // 处理图片懒加载
            {
                var tpl = $('#tpl_default_img').html();
                var imgs = $("img");
                for(var i = 0 ; i < imgs.length; i++)
                {
                    var it = $(imgs[i]);
                    var imgWH = {};
                    obj.needResizeHeight =true;
                    var img_w = parseInt(it.attr("width"));
                    var img_h = parseInt(it.attr("height"));

                    if(!isNaN(img_h) && img_h != 0  && img_h != "" && !isNaN(img_w) && img_w != 0 && img_w != ""){
                        obj.needResizeHeight = false;
                        if (img_w > body_width) {
                            imgWH.width = body_width;
                            imgWH.height = parseInt(img_h * body_width / img_w);

                            if(imgWH.height < 200){
                                imgWH.height = 200;
                            }
                        }else{
                            imgWH.width = body_width;
                            imgWH.height = img_h;
                        }
                    }else{
                        obj.needResizeHeight = true;
                        imgWH.width = body_width;
                        imgWH.height = 200;
                    }

                    var tpldata =
                    {
                        bodyWidth:body_width,
                        width:imgWH.width,
                        height:imgWH.height,
                        src : it.attr("original-src"),
                        showImgText : this.setting.showImgText
                    };
                    var node = $(juicer(tpl, tpldata));
                    it.after(node);
                    it.remove();

                    node.bind('click', function()
                    {
                        obj.renderImage($(this), false, false);
                        JNative.clickToLoadPic();
                    });
                }

                // 处理报表
                var report = $('.report');
                for(var i = 0 ; i < report.length; i++)
                {
                    var it = $(report[i]);
                    it.attr('src', it.attr("original-src"));
                }
            }

            // 处理文字模式下的图集事件
            {
                //所有非图集图片，非链接图片
                //
                var imgs = $("section .panel[type='img']").not(".drnews-gallery .panel[type='img']").not("a .panel[type='img']");

                for(var i = 0; i < imgs.length; i++){
                    var it = $(imgs[i]);
                    it.bind("click",function(e){
                        var status = $(this).attr("status");
                        var key = $(this).find("img").attr('src');
                        if( status == 0 ){
                            e.preventDefault();
                        }else{
                            JNative.onImageClickListener(obj.setting.articleId,key,obj.setting.isOnLine);
                        }

                    })
                }

                //所有图集
                var gallery = $("section .drnews-gallery");
                for( var i = 0; i < gallery.length; i++){
                    var it = $(gallery[i]);
                    it.bind('click',function(e){
                        var status = $(this).find(".panel[type='img']").attr("status");
                        var key  = $(this).find("figure").attr("data-key");
                        if( status == 0 ){
                            e.preventDefault();
                        }else{
                            if(key != undefined && key.length > 0){
                                JNative.onGalleryClickListener(obj.setting.articleId,key,obj.setting.isOnLine);
                            }
                        }
                    })
                }
            }


            // 处理video视频懒加载
            {
                var tpl = $('#tpl_video_img').html();
                var videos = $("video");
                for(var i = 0 ; i < videos.length; i++)
                {
                    var it = $(videos[i]);
                    var tpldata =
                    {
                        src : it.attr("original-src"),
                        poster : it.attr("original-poster")
                    };
                    var node = $(juicer(tpl, tpldata));
                    it.after(node);
                    it.remove();
                    if(!this.setting.autoShowImg)
                    {
                        node.bind('click', function()
                        {
                            obj.renderVideo($(this), true);
                        });
                    }
                }

                // 同一时间只允许播放一个video视频
                $('video').bind("play", function()
                {
                    var videos = $('video');
                    for(var i = 0 ; i < videos.length; i++)
                    {
                        if(videos[i] != this)
                        {
                            videos[i].pause();
                        }
                    }
                });
            }

            // 处理iframe视频懒加载
            {
                var tpl = $('#tpl_video_iframe_img').html();
                var iframe = $("iframe");
                for(var i = 0 ; i < iframe.length; i++)
                {

                    var it = $(iframe[i]);
                    var url = it.attr("original-src");
                    if(url != undefined && url.match(/youtu[be]/ig)){
                        var tpldata =
                        {
                            src : it.attr("original-src")
                        };
                        var node = $(juicer(tpl, tpldata));
                        it.after(node);
                        it.remove();
                        if(!this.setting.autoShowImg)
                        {
                            node.bind('click', function()
                            {
                                obj.renderIframeVideo($(this), true);
                            });
                        }
                    }else{
                        it.attr("src",it.attr("original-src"));
                    }
                }
            }

               //处理script
            {
               var js = $("section script");
               for(var i = 0; i < js.length; i++)
               {
                   it = $(js[i]);
                   var scriptNode = "";
                   if(it.html())
                   {
                         scriptStr = "<script type=\"text/javascript\">" + it.html() + "</script>";
                    }
                   if(it.attr("original-src"))
                   {
                          scriptStr = "<script type=\"text/javascript\" src=\"" + it.attr("original-src") + "\"></script>";
                    }
                     it.after($(scriptStr));
                     it.remove();
                }

             }




            this.panels = $(".panel");

            // 自动显示第一屏
            obj.onScrollListener(0);

            // 回调Native
            JNative.onRenderFinish();
            //定时器初始化，开始执行高度计算。
            obj.intervalInit();
        },


        //动态计算高度
        autoResizeHeight:function(){
            var height =document.body.getBoundingClientRect().height;
            if(obj.needHeight == 0){
                 obj.needHeight = height;
                 JNative.resize(obj.needHeight);
             }else{
                if( obj.needHeight != height ){
                    obj.needHeight = height;
                    JNative.resize(obj.needHeight);
                }
             }

        },


        /**
         * 定时器初始化，开始执行高度计算。
         */
        intervalInit:function(){
            // 开始显示计算高度。
            obj.autoResizeHeight();

           //间隔1.5秒执行一次检测
           interval = setInterval(function(){
                      obj.autoResizeHeight();
            },1500);

           //执行5分钟，结束定时器任务
           timeOut = setTimeout(function(){
                if(interval){
                    clearInterval(interval);
                }

                if(timeOut){
                    clearTimeout(timeOut);
                }

            },300000);

        },

        /**
         *恢复计算
         */
        resumeIntervalToCalculateHeight:function(){

          var height =document.body.getBoundingClientRect().height;
          //高度不对等，且计算的高度不为0时，此时的场景为刚进入页面或快速离开页面导致高度计算未完成情况
          if(obj.needHeight != height && height !=0){
            obj.intervalInit();
          }
        },

        // 滚动监听回调
        onScrollListener : function(scrollTop)
        {
            // 自动显示图片， 监听滚动条
            if(this.setting.autoShowImg)
            {
                this.autoScrollRender(scrollTop);
            }
        },

        // 单图退出(可订阅回调)
        onImageExit : function(imageSrc,callback)
        {
            var offseTop = 0;
            for( var i = 0; i < this.panels.length; i++){
                var panel = $(this.panels[i]);
                var src = panel.attr("original-src");
                if(src == imageSrc){
                    //图标若没有加载，则先加载图片
                    if(panel.attr("status") == 0){
                        this.renderImage(panel, true, true);
                        //console.log("renderImage 渲染");
                    }
                    offseTop = panel.offset().top;
                }
            }

            //console.log("图片的地址是 = " +　imageSrc + " | offseTop = " + offseTop);
            if(callback){
                JNative.onImageExitListener(obj.setting.articleId,offseTop);
                //console.log("onImageExitListener true");
            }
        }
    };

    // 开放Native API
    var api =
    {
        /**
         * 客户端渲染
         * cfg 全局配置json字符串
         */
	    render : function(cfg)
	    {
	        obj.render(cfg);
	    },

        /**
         * native滚动条回调
         * scrollTop 客户端滚动条卷入的高度, 虚拟像素值, android/ios必须转成dp单位
         */
	    onScrollListener : function(scrollTop)
	    {
	        obj.onScrollListener(scrollTop);
	    },

        /**
         * 单页图集退出传值
         * 根据指定图地址，索引到对应的offset Top, android/ios必须转成dp单位
         */
        onImageExit:function(imageSrc,callback)
        {
            obj.onImageExit(imageSrc,callback);
        },

        /**
         * 客户端根据实际情况， 在退出阅读的时候调用销毁js上下文
         */
	    destroy : function()
	    {
            var videos = $('video');
            for(var i = 0 ; i < videos.length; i++)
            {
                videos[i].pause();
            }
            var iframe = $('iframe');
            for(var i = 0 ; i < iframe.length; i++)
            {
		        iframe.eq(i).attr("original-src",iframe.eq(i).attr("src"));
                iframe.eq(i).attr("src",iframe.eq(i).attr("original-src"));
            }

            if(interval){
                clearInterval(interval);
            }

            if(timeOut){
                clearTimeout(timeOut);
            }
	    },

	    /**
	     * 恢复定时器计算高度，用于页面恢复时检测。
	     */
	    resumeIntervalToCalculateHeight:function(){

            obj.resumeIntervalToCalculateHeight();

	    }


    };
	window.News = api;
})();